image: wurssb/memote

# Gitlab runner should clone entire git repo not just head
# Run the validator
# Generate report
# Git clone history with pages branch
# Add content to pages branch
# Push pages branch back to gitlab...

#Makes a result folder to copy back and forth the new results
before_script:   
    # install ssh-agent
    # - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
    
    # run ssh-agent
    - eval $(ssh-agent -s)
    
    # add ssh key stored in SSH_PRIVATE_KEY variable to the agent store
    - ssh-add <(echo "$SSH_PRIVATE_KEY")
    
    # disable host key checking (NOTE: makes you susceptible to man-in-the-middle attacks)
    # WARNING: use only in docker container, if you use it with shell you will overwrite your user's ssh config
    - mkdir -p ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - chmod 400 ~/.ssh/config
    
    ## Memote specific part ##

    # Make sure memote is up-to-date - docker should be continously updated
    #- pip install memote --upgrade
    # Setup credentials and temp results folder
    - mkdir -p ../results
    - git config --global user.email "memote@gitlabrunner.com"
    - git config --global user.name "Memote runner"
    - git config --global push.default simple

gitRun:
  script:
  # Check for exit code! See if we can use that...?
  
  # Making sure we have the right remote
  - git remote get-url --all origin
  - git remote set-url origin $GITREPO

  # Makes sure the Results folder exists
  - mkdir -p ./results ../results

  # Works on the master branch or should this be the commit branch?
  # We need the gh-pages branch
  - git checkout gh-pages
  - GIT_SSH_COMMAND="ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no" git pull # To sync with remote 
  
  - git checkout master

  # Runs the model and stores all in the Results folder
  - memote run --location results model.xml  || true #Otherwise gitlab stops
  # Test history
  - memote report history || true # Otherwise gitlab stops # was >> memote report history Results || true # Otherwise gitlab stops
  # Creates a snapshot of the current state and stores in index.html
  - memote report snapshot model.xml  || true #Otherwise gitlab stops
  # Copy changes/results to / for moving to another branch
  #- cp ./results/* ../results/ # EMPTY?
  - cp index.html ../index.html
  # Due to git checkout issues
  - rm index.html
  # Undo all changes we had...?
  # - git reset --hard
  # Checking out gh-pages
  - git checkout gh-pages
  - GIT_SSH_COMMAND="ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no" git pull # To sync with remote 
  # Results might not yet exist....
  # - mkdir -p ./results/
  # Copy results back...
  # - cp ../results/* ./results/ # Nothing there??
  - cp ../index.html ./index.html
  - GIT_SSH_COMMAND="ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no" git pull # To sync with remote 
  # Make a commit and push back
  - git add .
  - git commit -m "Model results"
  # Auto accepts key / https://stackoverflow.com/questions/7772190/passing-ssh-options-to-git-clone#28527476
  - GIT_SSH_COMMAND="ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no" git push
  
  
pages:
  stage: deploy
  script:
  - echo 'Nothing to do...'
  artifacts:
    paths:
    - public
  only:
  - gh-pages

